If Not Diff statement in ksh 88


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting If Not Diff statement in ksh 88
# 1  
Old 07-17-2013
If Not Diff statement in ksh 88

Hi
I tried the below code where it is working properly
Code:
#!/bin/ksh
set -x
date1_data=abc.txt
date2_data=bcd.txt
if diff $date1_data $date2_data >/dev/null ; then
   echo "Equal"
else
   echo "Not Equal"
  fi

Then I tried like below where i want to use only if fi not else part
Code:
#!/bin/ksh
set -x
date1_data=abc.txt
date2_data=bcd.txt
if not diff $date1_data $date2_data >/dev/null ; then
   echo "NotEqual"
  fi

The above code is giving the error saying

not: not found


Please advice me where the script is wrong

Last edited by smile689; 07-17-2013 at 06:55 AM..
# 2  
Old 07-17-2013
there is no not command in ksh. try ! or test
This User Gave Thanks to vidyadhar85 For This Post:
# 3  
Old 07-17-2013
diff returns 0 when no differences are found, 1 when there are differences, >1 (2,3,4...)
when there was an error.

Probably the best usage is to cover all possibilities by looking for all the return values.
simple example:
Code:
diff filea fileb > /dev/null
rc=$?
[ $rc > 1 ] && echo 'fatal error'  && exit 1
[ $rc -eq 0 ] && echo 'same'
[ $rc -eq 1] && echo 'different'

This User Gave Thanks to jim mcnamara For This Post:
# 4  
Old 07-17-2013
Try
Code:
diff file1 file2 || echo "not equal"

Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Same KSH behaving differently on diff servers

HI all I have written a ksh to execute PL/sql procedure and generate the log file. The script is working fine to the extent of calling the taking input, executing PL/SQL procedure. On one server the log file is getting generated properly. i,e it shows the DBMS output . The log file size was... (9 Replies)
Discussion started by: ramakrishnakini
9 Replies

2. Shell Programming and Scripting

KSH If statement.

How can I search get if to pinpoint 1 word in a line and have it do something for me? example: KEY1="<< Response ... Total of 2 >> Sun Jun 19 15:30:18 2011 Tx Power Level is 27.7 Bm ~ " if ]; then command; else error; fi Thats just a quick sample. I want my if statement to se the... (5 Replies)
Discussion started by: 82280zx
5 Replies

3. Shell Programming and Scripting

If statement is not working in KSH

#! /bin/ksh rm -f ./xyz file --- this line is working // Below any if stmt is not working. if then echo " blah blah " fi or I replaced above if with if then echo "dir exists" fi This is also not working. I am new to KSH. So can someone help why if stmt is not... (31 Replies)
Discussion started by: saggy9583
31 Replies

4. UNIX for Dummies Questions & Answers

Using 'diff' exit status in an if statement

is there a way to compare two files using diff (ex: diff 1.txt 2.txt) in an if statement? I read that the exit status of diff is 0 if the files contain the same content. 1 if they're different. So what I am attempting is basically: if ; then echo "they're the same" else ... (2 Replies)
Discussion started by: SoVi3t
2 Replies

5. Shell Programming and Scripting

KSH if statement

Hi guys, im new to UNIX so bear with me. would it be possible for me to create an if statement where i can have a key being entered and something happening after that. (bad explanation) eg. If user enters letter 'q' then close window or exit puTTy Thanks in advance (1 Reply)
Discussion started by: robbrad
1 Replies

6. UNIX for Dummies Questions & Answers

foreach statement in ksh

Hi, My script should run through all subdirs recursively in SUBDIR_LIST, run a clearcase command in each subdir, print to the merge_results1.txt and add a new line to the results before going to the next subdir. All the results should append to merge_results1.txt, but are seperated by a line so... (8 Replies)
Discussion started by: asulli01
8 Replies

7. Shell Programming and Scripting

how to use if statement in ksh script

Hi, I need to compare two variables using if condition and i am not sure if am right or wrong. My code is like : if then echo "new file" else echo "old file and remove it" fi where both variables contain time : filetime contains the time when a file... (2 Replies)
Discussion started by: manmeet
2 Replies

8. Shell Programming and Scripting

Help with if statement in ksh script

I need a way to grep for a string in a file and if it finds it, to print set a variable to "Yes", if it doesn't find the string in a file to set the variable to "No". I plan on using these variables to print a table that lists whether the string was found or not. For example print "File ... (2 Replies)
Discussion started by: stepnkev
2 Replies

9. UNIX for Dummies Questions & Answers

Let statement in ksh HELP

I have: datafile contains 1234567890 >wc -c datafile | awk '{print $1}' >11 The program #!/bin/ksh let n = (wc -c datafile | awk '{print $1}') echo $n I expect n to be 11 but it gives error message. What is wrong with this statement? Thanks! (3 Replies)
Discussion started by: bobo
3 Replies

10. UNIX for Dummies Questions & Answers

if statement in ksh

what is the problem with this comparison in ksh script: if " ] it gives syntx error (3 Replies)
Discussion started by: gfhgfnhhn
3 Replies
Login or Register to Ask a Question